<template>
  <section class="selectDeptUser">
    <div class="header-middle">
      <div class="hint">
        <span v-for="(item, index) in selectDeptPath" :key="index">
          <span v-if="index>0" class="mar-h4">/</span>
          <span class="color-3F8DF5" @click="deptNameClick(item, index)">{{ item.name }}</span>
        </span>
      </div>
      <div class="cards" v-for="item in treeList" :key="item.id" @click="itemClick(item)">
        <div class="imges">
          <div class="imgselect" v-if="type == 1" :class="{checked:item.isChecked}" />
          <img src="./img/gird--select-icon.png" alt="" class="avatras"/>
        </div>
        <div class="rightes">
          <div class="applicationNames">{{ item.name }}</div>
          <img src="./img/right-icon.png" alt="" class="imgs"/>
        </div>
      </div>
      <div v-if="type == 0">
        <div class="userCards" v-for="(e, userIndex) in userList" :key="e.id">
          <div class="imges">
            <div class="imgselect" :class="{checked:e.isChecked}" @click.stop="itemCheck(e, 'user', userIndex)"/>
            <img src="./img/tx@2x.png" alt="" class="avatras"/>
          </div>
          <div class="rights fill">
            <div class="applicationNames" v-text="e.name"></div>
            <div class="idNumbers">{{ e.phone }}</div>
          </div>
        </div>
      </div>
      <AiEmpty description="暂无数据" v-if="!hasData"/>
    </div>
    <div class="subBtn" @click="submit">
      <div>确定选择</div>
    </div>
  </section>
</template>

<script>
import { mapState } from "vuex";
export default {
  name: "selectDeptUser",
  appName: "选择人员",
  data() {
    return {
      selected: [],
      allData: null,
      treeList: [],
      selectDeptPath: [],
      userList: [],
      type: 0,
    }
  },
  computed: {
    isSingle: v => !!v.$route.query.single,
    nodeKey: v => v.$route.query.nodeKey || "id",
    isRequire: v => v.$route.query.isRequire || 1,
    hasData() {
      return this.treeList?.length > 0 || this.userList?.length > 0
    },
    ...mapState(['user'])
  },
  onLoad(query) {
    if (query.selected) {
      this.selected = query.selected?.split(",") || []
    }
    this.getListAll() 
  },
  methods: {
    isSelected(id) {
      return !!this.selected.find(e => e == id)
    },
    getListAll() {
      this.$instance.post('/app/wxcp/wxdepartment/listAllByCorp').then((res) => {
        if (res?.data) {
          let parents = res.data.map(e => e.parentid)
          this.allData = res.data.map(e => ({...e, hasChildren: parents.includes(e.id), isChecked: this.isSelected(e.id)}))
          this.deptInit()
        }
      })
    },
    deptInit() {
      this.treeList = this.allData.filter(e => !e.parentid)
      this.selectDeptPath = [{name: "可选范围", id: ''}]
    },
    itemClick({id, name, corpId}) {
      let index = this.selectDeptPath.findIndex(e => e.id == id && e.corpId == corpId)
      if (index == -1) {
        this.selectDeptPath.push({name, id, corpId})
        this.getDeptsAndUsersByParent(id, corpId)
      }
    },
    getDeptsAndUsersByParent(departmentId, corpId) {
      this.treeList = this.allData.filter(e => e.parentid == departmentId && e.corpId == corpId)
      this.userList = []
      this.$instance.post(`/app/wxcp/wxuser/listByDeptId`, null, {
        params: {departmentId, status: 1, cid: corpId}
      }).then(res => {
        if (res?.data) {
          this.userList = res.data.map(e => ({...e, isChecked: this.isSelected(e.id, e.corpId)}))
        }
      })
    },
    deptNameClick(row, index) {
      this.userList = []
      if (!index) { //第一级别
        this.deptInit()
      } else {
        let length = this.selectDeptPath.length - index
        this.selectDeptPath.splice(index + 1, length)
        this.getDeptsAndUsersByParent(row.id, row.corpId)
      }
    },
    itemCheck(row, kind, index) {
      if(this.isSingle) {
        this.selected = []
        this.userList.map((item) => {
          item.isChecked = false
        })
        this.userList[index].isChecked = true
        this.selected.push({...row, kind})
      } else {
        row.isChecked = !row.isChecked
        if (row.isChecked) {
          this.selected.push({...row, kind})
        } else {
          let index = this.selected.findIndex(e => e.id == row.id)
          this.selected.splice(index, 1)
        }
      }
      this.$forceUpdate()
    },
    submit() {
      if(![this.selected].flat().length) {
        return this.$u.toast('请选择人员')
      }
      uni.navigateBack({
        success: () => {
          uni.$emit("pagePicker:deptUser",  this.selected)
        }
      })
    },
  }
}
</script>

<style lang="scss" scoped>
.selectDeptUser {
  height: 100%;
  background: #fff;

  .header-top {
    background: #fff;
    padding: 20px 32px;
  }

  .header-middle {
    padding-bottom: 140px;

    .hint {
      padding: 28px 20px 28px 32px;
      line-height: 56px;
      box-shadow: 0 1px 0 0 #e4e5e6;
      font-size: 30px;
      font-weight: 500;
      word-break: break-all;
    }

    .empty-div {
      height: 16px;
      background: #f5f5f5;
    }

    .imges {
      display: flex;
      align-items: center;

      .imgselect {
        width: 48px;
        height: 48px;
        vertical-align: middle;
        background-image: url("./img/xz.png");
        background-position: center;
        background-size: 100% 100%;

        &.checked {
          background-image: url("./img/xzh.png");
        }
      }

      .avatras {
        width: 74px;
        height: 74px;
        border-radius: 8px;
        margin-left: 36px;
      }
    }

    .cards {
      display: flex;
      align-items: center;
      height: 120px;
      line-height: 120px;
      padding: 0 0 0 32px;


      img {
        width: 74px;
        height: 74px;
        border-radius: 8px;
      }

      .rightes {
        width: calc(100% - 160px);
        display: flex;
        align-items: center;
        margin-left: 32px;
        border-bottom: 1px solid #e4e5e6;

        .applicationNames {
          flex: 1;
          min-width: 0;
          font-size: 36px;
          font-weight: 500;
          color: #333333;
          overflow: hidden;
          white-space: nowrap;
          text-overflow: ellipsis;
        }

        .imgs {
          flex-shrink: 0;
          width: 40px;
          height: 40px;
          margin-right: 20px;
        }
      }
    }

    .userCards {
      display: flex;
      align-items: center;
      height: 120px;
      line-height: 120px;
      padding: 0 0 0 32px;

      .rights {
        display: flex;
        justify-content: space-between;
        align-items: center;
        margin-left: 32px;
        border-bottom: 1px solid #e4e5e6;
        padding-right: 40px;
        height: inherit;

        .applicationNames {
          font-size: 36px;
          font-weight: 500;
          color: #333333;
          overflow: hidden;
          white-space: nowrap;
          text-overflow: ellipsis;
        }

        .idNumbers {
          color: #666;
        }
      }
    }
  }

  .subBtn {
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 118px;
    background: #f4f8fb;

    div {
      width: 192px;
      height: 80px;
      line-height: 80px;
      text-align: center;
      background: #1365dd;
      border-radius: 4px;
      font-size: 32px;
      color: #fff;
      margin: 20px 34px 0 0;
      float: right;
    }
  }

  .color-3F8DF5 {
    color: #3F8DF5;
  }

  .mar-h4 {
    margin: 0 4px;
  }
}
</style>
